#pragma once

#include "v3.h"
#include "framebuffer.h"
#include "ppc.h"

class Triangle {
public:
  V3 overts[3];
  V3 verts[3];
  V3 colors[3];
  Triangle (V3 v0, V3 v1, V3 v2);
  Triangle (V3 *ovs, V3 *pvs);
  void Rasterize(FrameBuffer *fb, PPC *ppc, unsigned int color);
  void DrawWireframe(FrameBuffer *fb, unsigned int color);
  void SetModelSpaceInterpolation(PPC *ppc, M3x3 &msiQ);
  void SetModelSpaceInterpolation(M3x3 &msiQ, V3 rvs,
    V3 *redABCDEF);

};